// $Id: helixbrk_e.h 577 2006-10-11 16:51:51Z indraneel $

#ifndef _HELIXBRK_E_H
#define _HELIXBRK_E_H

static const double ZEE_CUTOFF = 2.5;
static const double ANG_CUTOFF = 20.0;

// return data (can be null)
struct helices{
  int count;
  int *start, *end;
  float *rmsd;
  float *angle;
  int *len;
};

void debugmsg(char *message, int priority);
struct helices *chop_helix(double *data, int dp);

#endif /* _HELIXBRK_E_H */


