# $Id: DSSPRunner.py 577 2006-10-11 16:51:51Z indraneel $

import os
from DSSPElements import DSSPElements

class DSSPRunner:
    def runfile(self, logger, fname, typedef, etype, data_array, fn):
        dssp_elements = DSSPElements(logger, fname)
        dssp_elements.setType(typedef)
        elements = dssp_elements.getElements()
        for element in elements:
            if element.type != etype: continue
            fn(element, data_array)

    def rundir(self, logger, dirname, typedef, etype, data_array, fn):
        filelist = os.listdir(dirname)
        for i,filename in enumerate(filelist):
            filename = dirname + filename
            self.runfile(logger, filename, typedef, etype, data_array, fn)

