# $Id: Sigma.py 577 2006-10-11 16:51:51Z indraneel $

# calculates standard deviation of data

import math

class Sigma(list):
    def __sigma(self, mean):
        def difference_square(x):
            return ((x-mean)*(x-mean))
        S = map(difference_square, self)
        variance = sum(S)/(len(self)-1)
        standard_deviation = math.sqrt(variance)
        return standard_deviation

    def sigma(self, mean=None):
        if (mean == None):
            mean = sum(self)/len(self)
        return self.__sigma(mean)
