// $Id: helixbrk.h 577 2006-10-11 16:51:51Z indraneel $

#ifndef _HELIXBRK_H
#define _HELIXBRK_H

/* maximum potential breaks this code can handle
   malloc() removed for speed and easy code */
#define maxbrks (20)

struct result_cbn {
  int frags, dp;
  double *start[maxbrks];
  int len[maxbrks], overlap[maxbrks];
  double ui[maxbrks], uj[maxbrks], uk[maxbrks];
  double rmsd[maxbrks];
  double angle[maxbrks];
  int startpos[maxbrks];
  int endpos[maxbrks];
};

static const int init = 10000000;

static const double avline_m = 0.0118275;
static const double avline_c = 2.17563;

static const double sigline_m = 0.0;
static const double sigline_c = 0.106913;

#endif /* _HELIXBRK_H */
